using System;
using System.Runtime.InteropServices;

namespace DesktopManager
{
    internal static class API
    {
        #region Fields
        public const int WM_COMMAND = 0x111;
        public const uint EWX_LOGOFF = 0;
        public const uint EWX_REBOOT = 0x2;
        public const uint EWX_POWEROFF = 0x8;
        public const uint EWX_FORCE = 0x4;
        public const uint SHTDN_REASON_MAJOR_OPERATINGSYSTEM = 0x20000;
        public const uint SHTDN_REASON_MINOR_UPGRADE = 0x3;
        public const uint SHTDN_REASON_FLAG_PLANNED = 0x80000000;
        #endregion

        #region Types
        [Flags]
        public enum HChangeNotifyFlags
        {
            SHCNF_DWORD = 0x0003,
            SHCNF_IDLIST = 0x0000,
            SHCNF_FLUSH = 0x1000,
            SHCNF_FLUSHNOWAIT = 0x2000
        }

        [Flags]
        public enum HChangeNotifyEventID
        {
            SHCNE_ALLEVENTS = 0x7FFFFFFF,
            SHCNE_ASSOCCHANGED = 0x08000000,
            SHCNE_CREATE = 0x00000002,
            SHCNE_DELETE = 0x00000004,
            SHCNE_DRIVEADD = 0x00000100,
            SHCNE_DRIVEADDGUI = 0x00010000,
            SHCNE_DRIVEREMOVED = 0x00000080,
            SHCNE_EXTENDED_EVENT = 0x04000000,
            SHCNE_MEDIAINSERTED = 0x00000020,
            SHCNE_MEDIAREMOVED = 0x00000040,
            SHCNE_MKDIR = 0x00000008,
            SHCNE_UPDATEDIR = 0x00001000,
            SHCNE_UPDATEIMAGE = 0x00008000,
        }
        #endregion

        #region Methods
        [DllImport( "user32.dll", EntryPoint = "SystemParametersInfo" )]
        internal static extern bool ChangeWallpaper( uint action, uint param, string paramArr, uint fWinIni );
        #endregion
    }
}
