using System;
using Microsoft.Win32;

namespace DesktopManager
{
    public static class Preferences
    {
        public static string SourceFolder
        {
            get
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", false );
                string source = Environment.SystemDirectory;
                source = source.Substring( 0, source.LastIndexOf( @"\" ) );
                source += @"\Web\Wallpaper\";
                source = (string)key.GetValue( "SourceFolder", source );
                key.Close();
                return source;
            }
            set
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", true );
                key.SetValue( "SourceFolder", value );
                key.Close();
            }
        }

        public static bool SwitchInterval
        {
            get
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", false );
                bool value = Convert.ToBoolean( (string)key.GetValue( "SwitchInterval", "False" ) );
                key.Close();
                return value;
            }
            set
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", true );
                key.SetValue( "SwitchInterval", value.ToString() );
                key.Close();
            }
        }

        public static double ChangeInterval
        {
            get
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", false );
                double value = Convert.ToDouble( (string)key.GetValue( "ChangeInterval", "60" ) );
                key.Close();
                return value;
            }
            set
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", true );
                key.SetValue( "ChangeInterval", value.ToString() );
                key.Close();
            }
        }

        public static bool ChangeAtLogon
        {
            get
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", false );
                bool value = Convert.ToBoolean( (string)key.GetValue( "ChangeAtLogon", "True" ) );
                key.Close();
                return value;
            }
            set
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", true );
                key.SetValue( "ChangeAtLogon", value.ToString() );
                key.Close();
            }
        }

        public static bool ChangeOnDoubleClick
        {
            get
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", false );
                bool value = Convert.ToBoolean( (string)key.GetValue( "ChangeOnDoubleClick", "False" ) );
                key.Close();
                return value;
            }
            set
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", true );
                key.SetValue( "ChangeOnDoubleClick", value.ToString() );
                key.Close();
            }
        }

        public static bool ChangeOnMouseHover
        {
            get
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", false );
                bool value = Convert.ToBoolean( (string)key.GetValue( "ChangeOnMouseHover", "False" ) );
                key.Close();
                return value;
            }
            set
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", true );
                key.SetValue( "ChangeOnMouseHover", value.ToString() );
                key.Close();
            }
        }

        public static string WatchDestinationFolder
        {
            get
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", false );
                string source = @"c:\";
                source = (string)key.GetValue( "WatchDestinationFolder", source );
                key.Close();
                return source;
            }
            set
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", true );
                key.SetValue( "WatchDestinationFolder", value );
                key.Close();
            }
        }

        public static bool WatcherStatus
        {
            get
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", false );
                bool value = Convert.ToBoolean( (string)key.GetValue( "WatcherStatus", "False" ) );
                key.Close();
                return value;
            }
            set
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", true );
                key.SetValue( "WatcherStatus", value.ToString() );
                key.Close();
            }
        }

        public static double WatchInterval
        {
            get
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", false );
                double value = Convert.ToDouble( (string)key.GetValue( "WatchInterval", "2" ) );
                key.Close();
                return value;
            }
            set
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", true );
                key.SetValue( "WatchInterval", value.ToString() );
                key.Close();
            }
        }

        public static bool TraceForEachWindow
        {
            get
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", false );
                bool value = Convert.ToBoolean( (string)key.GetValue( "TraceForEachWindow", "False" ) );
                key.Close();
                return value;
            }
            set
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", true );
                key.SetValue( "TraceForEachWindow", value.ToString() );
                key.Close();
            }
        }

        public static bool TranslateDesktopToNetwork
        {
            get
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", false );
                bool value = Convert.ToBoolean( (string)key.GetValue( "TranslateDesktopToNetwork", "False" ) );
                key.Close();
                return value;
            }
            set
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", true );
                key.SetValue( "TranslateDesktopToNetwork", value.ToString() );
                key.Close();
            }
        }

        public static bool BlockByUSBFlash
        {
            get
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", false );
                bool value = Convert.ToBoolean( (string)key.GetValue( "BlockByUSBFlash", "False" ) );
                key.Close();
                return value;
            }
            set
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", true );
                key.SetValue( "BlockByUSBFlash", value.ToString() );
                key.Close();
            }
        }

        public static string BlokerKeyfile
        {
            get
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", false );
                string source = "";
                source = (string)key.GetValue( "BlokerKeyfile", source );
                key.Close();
                return source;
            }
            set
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", true );
                key.SetValue( "BlokerKeyfile", value );
                key.Close();
            }
        }

        public static bool MonitorPowerOff
        {
            get
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", false );
                bool value = Convert.ToBoolean( (string)key.GetValue( "MonitorPowerOff", "False" ) );
                key.Close();
                return value;
            }
            set
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", true );
                key.SetValue( "MonitorPowerOff", value.ToString() );
                key.Close();
            }
        }

        public static bool PauseMediaPlayer
        {
            get
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", false );
                bool value = Convert.ToBoolean( (string)key.GetValue( "PauseMediaPlayer", "False" ) );
                key.Close();
                return value;
            }
            set
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", true );
                key.SetValue( "PauseMediaPlayer", value.ToString() );
                key.Close();
            }
        }

        public static string NextFile
        {
            get
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", false );
                string source = "";
                source = (string)key.GetValue( "NextFile", source );
                key.Close();
                return source;
            }
            set
            {
                RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", true );
                key.SetValue( "NextFile", value );
                key.Close();
            }
        }
    }
}