using Microsoft.Win32;

namespace DesktopManager
{
    public enum WallpaperPositions
    {
        Stretched,
        Centered,
        Tiled
    }

    public static class WallpaperPositionStyle
    {
        public static void Apply( WallpaperPositions style )
        {
            RegistryKey key = Registry.CurrentUser.OpenSubKey( @"Control Panel\Desktop", true );
            switch ( style ) {
                case WallpaperPositions.Stretched:
                    key.SetValue( "WallpaperStyle", "2" );
                    key.SetValue( "TileWallpaper", "0" );
                    break;
                case WallpaperPositions.Centered:
                    key.SetValue( "WallpaperStyle", "1" );
                    key.SetValue( "TileWallpaper", "0" );
                    break;
                case WallpaperPositions.Tiled:
                    key.SetValue( "WallpaperStyle", "1" );
                    key.SetValue( "TileWallpaper", "1" );
                    break;
            } // switch
            key.Close();
        }
    }
}
