using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.IO;

namespace DesktopViewer
{
    public partial class FM : Form
    {
        private IPAddress ip;
        private int port = 13666;
        private TcpClient client = null;
        private NetworkStream stream = null;
        private byte[] data = new byte[2 * 1024 * 1024];
        private MemoryStream ms = new MemoryStream();

        public FM()
        {
            InitializeComponent();
            Hide();
        }

        private void btnConnect_Click( object sender, EventArgs e )
        {
            if ( client != null ) {
                stream.Close();
                client.Close();
            } // if

            ip = IPAddress.Parse( tbServerIP.Text );
            client = new TcpClient();
            client.Connect( ip, port );
            client.ReceiveBufferSize = data.Length;
            client.ReceiveTimeout = 4000;
            client.SendBufferSize = data.Length;
            client.SendTimeout = 4000;
            stream = client.GetStream();

            timerUpdate.Enabled = true;
        }

        private void timerUpdate_Tick( object sender, EventArgs e )
        {
            try {
                int c = stream.Read( data, 0, data.Length );
                if ( c == 0 )
                    return;

                ms.Write( data, 0, c );
                Image img = pbImage.Image;
                pbImage.Image = Image.FromStream( ms );
                if ( img != null )
                    img.Dispose();
                ms.SetLength( 0 );

                pbImage.Update();
                Update();
            } catch { }
        }
    }
}